PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
PNotifierFunctionTemplate< ParamType > Class Template Referenceabstract

This is an abstract class for which a descendent is declared for every function that may be called. More...

`#include <notifier.h>`

Inheritance diagram for PNotifierFunctionTemplate< ParamType >:
[legend]
Collaboration diagram for PNotifierFunctionTemplate< ParamType >:
[legend]

## Public Member Functions
virtual void | Call (PObject &notifier, ParamType extra) const =0
| Execute the call to the actual notification function on the object instance contained in this object. More...
virtual void * | GetTarget () const
Public Member Functions inherited from PSmartObject
| PSmartObject ()
| Construct a new smart object, subject to a `PSmartPointer` instance referencing it. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Member Functions
| PNotifierFunctionTemplate (void *target, void *=NULL)
| Create a notification function instance. More...

## Protected Attributes
void * | m_target
| Object instance to receive the notification function call. More...
Protected Attributes inherited from PSmartObject
PAtomicInteger | referenceCount
| Count of number of instances of `PSmartPointer` that currently reference the object instance. More...
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Friends inherited from PObject

## Detailed Description

### template<typename ParamType>
class PNotifierFunctionTemplate< ParamType >

This is an abstract class for which a descendent is declared for every function that may be called.

The `PDECLARE_NOTIFIER` macro makes this declaration.

The `PNotifier` and `PNotifierFunction` classes build a completely type safe mechanism for calling arbitrary member functions on classes. The "pointer to a member function" capability built into C++ makes the assumption that the function name exists in an ancestor class. If you wish to call a member function name that does not exist in any ancestor class, very type unsafe casting of the member functions must be made. Some compilers will even refuse to do it at all!

To overcome this problem, as this mechanism is highly desirable for callback functions in the GUI part of the PTLib library, these classes and a macro are used to create all the classes and declarations to use polymorphism as the link between the caller, which has no knowledege of the function, and the receiver object and member function.

This is most often used as the notification of actions being take by interactors in the PTLib library.

## Constructor & Destructor Documentation

template<typename ParamType >

PNotifierFunctionTemplate< ParamType >::PNotifierFunctionTemplate | ( | void * | target,
|  | void * | = `NULL`
| ) |  |
| inline protected

Create a notification function instance.

Parameters

  target | Object instance on which the function will be called on.

References PNotifierFunctionTemplate< ParamType >::m_target, and PAssertNULL.

## Member Function Documentation

template<typename ParamType >

virtual void PNotifierFunctionTemplate< ParamType >::Call | ( | PObject & | notifier,
|  | ParamType | extra
| ) |  | const
| pure virtual

Execute the call to the actual notification function on the object instance contained in this object.

Parameters

  notifier | Object that is making the notification.
  extra | Extra information that may be passed to function.

Referenced by PNotifierTemplate< PChannel::AsyncContext & >::operator()().

template<typename ParamType >

virtual void* PNotifierFunctionTemplate< ParamType >::GetTarget | ( |  | ) | const
| inline virtual

Reimplemented in PValidatedNotifierFunction< ParamType >.

References PNotifierFunctionTemplate< ParamType >::m_target.

Referenced by PNotifierTemplate< PChannel::AsyncContext & >::GetTarget().

## Member Data Documentation

template<typename ParamType >

void* PNotifierFunctionTemplate< ParamType >::m_target
| protected

Object instance to receive the notification function call.

Referenced by PNotifierFunctionTemplate< ParamType >::GetTarget(), PValidatedNotifierFunction< ParamType >::GetTarget(), and PNotifierFunctionTemplate< ParamType >::PNotifierFunctionTemplate().

The documentation for this class was generated from the following file:

- notifier.h